package tests;

import org.junit.Before;
import org.junit.Test;
import static org.junit.Assert.*;


import abstractions.PairOfIntegersAbstraction;


public abstract class JUnit_PairOfIntegersAbstractionTest extends JUnit_PairAbstractionTest{

		
	/**
	 *  Should initialise defaultPair using default constructor with value (0,0)<br>
	 *  Should initialise nonDefaultPair using non-default constructor with value (1,2)<br>
	 *  Should initialise copiedPair using copy constructor on defaultPair <br>
	 */
	@Before
	public abstract void setUp();
	
    /**
     * The default integer values of first and second should be 0
     */
	@Override
	public void testDefaultConstructor() {
		
		assertEquals(PairOfIntegersAbstraction.DEFAULT_FIRST, defaultPair.getFirst());
		assertEquals(PairOfIntegersAbstraction.DEFAULT_SECOND, defaultPair.getSecond());
	}
	
	@Override
	public void testNonDefaultConstructor() {
		
		assertEquals(1, nonDefaultPair.getFirst());
		assertEquals(2, nonDefaultPair.getSecond());
	}
	
	@Override
	public void testGetFirst() {
		assertEquals(PairOfIntegersAbstraction.DEFAULT_FIRST, defaultPair.getFirst());
		
	}

	@Override
	public void testGetSecond() {
		assertEquals(PairOfIntegersAbstraction.DEFAULT_SECOND, defaultPair.getSecond());
		
	}


	@Override
	public void testSetFirst() {
		
		for (int i =0; i<10; i++){
		    defaultPair.setFirst(new Integer(i));
		    assertTrue( (Integer) defaultPair.getFirst()== i);
		}
	 }
	
	@Override
	public void testSetSecond() {
		
		for (int i =0; i<10; i++){
		    defaultPair.setSecond(new Integer(i));
		    assertTrue( (Integer) defaultPair.getSecond()== i);

		}
	 }
	
	@Test
	public 	void testEquals(){
		
		super.testEquals();
		
		copiedPair.setFirst(1);
		defaultPair.setFirst(2);

	}
	


}