import java.sql.Date;
import java.util.LinkedList;

/**
 * Generic class that defines a wrapper class around a single 
 * element of a generic type. 
 */
public class Box<T> {

    private T t;          

    public void set(T t) {
        this.t = t;
    }

    public T get() {
        return t;
    }
/**
 * Generic method that uses both the generic type of the class
 * it belongs to, as well as an additional generic type 
 */
    public void inspect(){
    	System.out.println("in Box::inspect()");
        System.out.println("T: " + t.getClass().getName());
    }
    
    public <U> U inspectAndReturnWithAdditionalType(U u){
    	System.out.println("in Box::inspectAndReturnWithAdditionalType()");
        System.out.println("T: " + t.getClass().getName());
        System.out.println("U: " + u.getClass().getName());
        return u;
    } 
    
    public static void main(String[] args) {
        Box<Double> numberBox = new Box<Double>();
        //numberBox.set(new Integer(10));
        //numberBox.inspect();
        numberBox.set(new Double(10));
        numberBox.inspect();
        Double d = numberBox.get();
        String s = numberBox.inspectAndReturnWithAdditionalType("Hello world");
        Box<?> b = new Box<Integer>();
        Box<?> c = new Box<Integer>();
        b.set(new Integer(1));
        c.set(new Integer(1));

        b.inspect();
    }
}